#include <iostream>
#include <vector>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin >> n >> q;
    vector<int> a(n);
    int maxx=0;
    for(int i=0;i<n;i++)
    {
        cin >> a[i];
        if(a[i]>maxx) maxx=a[i];
    }
    int maxd=0;
    while(maxx>0)
    {
        maxd++;
        maxx/=2;
    }
    int brojNula [22][200005];
    for(int i=0;i<maxd;i++) brojNula[i][0]=0;
    vector<int> b(n);
    for(int i=0;i<n;i++) b[i]=a[i];
    for(int i=0;i<maxd;i++)
    {
        for(int j=1;j<=n;j++)
        {
            brojNula [i][j] =  brojNula[i][j-1] + 1 - (b[j-1]%2);
            b[j-1]/=2;
        }
    }
    for(int i=0;i<q;i++)
    {
        int l,r;
        cin >> l >> r;
        int m[25];
        for(int j=0;j<maxd;j++)
        {
            if(brojNula[j][r]-brojNula[j][l-1]==0) m[j]=1;
            else m[j]=0;
        }

        int rez=0;
        int qw=1;
        for(int j=0;j<maxd;j++, qw*=2)
        {
            rez+=m[j]*qw;
        }
        cout << rez << endl;
    }
    return 0;
}